
import RPi.GPIO as GPIO
import time

class StepperMotorDriver():
    """
    Class representing a stepper motor.
    """
    CW = 0
    CCW = 255
    
    #def __init__(self, pinMD, pinIn1A, pinIn2A, pinIn1B, pinIn2B, gpio_expander):
    def __init__(self, stepSig, stepDir, stepEna):
        """
        Initializes the motor
    
        pin - pin the motor is attached to
        """
        #self.pinMD = pinMD
        self.stepSig = stepSig
        self.stepDir = stepDir
        self.stepEna = stepEna
        GPIO.setup(self.stepSig, GPIO.OUT)
        GPIO.setup(self.stepDir, GPIO.OUT)
        GPIO.setup(self.stepEna, GPIO.OUT)
        

        
    def stop(self):
        #TODO connect to enable
        """
        stops motor
        """
        GPIO.output(self.stepEna, 1)
        
    def step(self):
        GPIO.output(self.stepSig, 1)
        GPIO.output(self.stepSig, 0)

        
    def write(self, direction, steps=1, delay=.005):
        """
        writes a value to the motor to drive it
        
        direction - direction for the motor to turn 
        steps - number of steps to drive the motor forward
        delay - delay between parts of steps. Total delay time = 4 * delay * steps
        """
        GPIO.output(self.stepEna, 0)
        if direction == "EXTEND": 
            GPIO.output(self.stepDir, 0)
            for _ in range(0, steps):
                self.step()
                time.sleep(delay)
        else:
            for _ in range(0, steps):
                GPIO.output(self.stepDir, 1)
                self.step()
                time.sleep(delay)
