#Imports
import termios, fcntl, sys, os
from time import sleep
sys.path.append(os.path.join(os.path.dirname(__file__), ".."));
import src
import RPi.GPIO as GPIO

from managers.sensor_manager import SensorManager
from managers.setup_motor_manager import SetupMotorManager

sensor_manager = SensorManager()
drive_manager = SetupMotorManager(sensor_manager)

# Functions
def clear():
    os.system('cls' if os.name == 'nt' else 'clear')

def getKey():
    c = 0  
    i = 0
    # The recommended minimum is 1000
    while(c == 0 and i < 1200):
        try:
            c = sys.stdin.read(1)
            print "Got character", repr(c)
        except IOError: pass
        i = i + 1
    return c



#Main code
fd = sys.stdin.fileno()

oldterm = termios.tcgetattr(fd)
newattr = termios.tcgetattr(fd)
newattr[3] = newattr[3] & ~termios.ICANON & ~termios.ECHO
termios.tcsetattr(fd, termios.TCSANOW, newattr)

oldflags = fcntl.fcntl(fd, fcntl.F_GETFL)
fcntl.fcntl(fd, fcntl.F_SETFL, oldflags | os.O_NONBLOCK)

key = 0
motor = drive_manager.gimbleMotorPitch1

while (key != '\n'):
    key = getKey()
    
    if (key == '1'):
        motor.write("CW", 100)
    if (key == '2'):
        motor.write("CCW", 100)
    if (key == '3'):
        motor.write("CW", 0)
    if (key == '4'):
        motor.write("CCW", 0)
    if (key == '5'):
        motor.stop()
    if (key == '6'):
        motor.pwm.ChangeDutyCycle(0)
    if (key == '7'):
        motor.pwm.stop()
    if (key == '8'):
        motor.pwm.start(100)
    if (key == '9'):
        motor.pwm.start(0)
    if (key == 0):
        motor.stop()



termios.tcsetattr(fd, termios.TCSAFLUSH, oldterm)
fcntl.fcntl(fd, fcntl.F_SETFL, oldflags)
clear()
