# Test multiprocess python server
import threading
import time
import logging
import random
import socket
import numpy


logging.basicConfig(level=logging.DEBUG,
    format='[DEBUG] [%(threadName)-10s] %(message)s',
    )

threads = []

MSGLEN = 100

def mysend(sock, message):
    msg = numpy.chararray([100])
    msg.fill('\0')
    i = 0
    for c in message:
        try:
            msg[i] = c
            i = i + 1
        except: pass
    sock.send(msg)
    
def myrecv(sock):
    msg = sock.recv(MSGLEN)
    return msg

def arrayComp(a, b):
    return str(toCharArray(a).flatten()) == str(toCharArray(b).flatten())

def arrayCompN(a, b, n):
    result = True
    a = toCharArray(a).flatten()
    b = toCharArray(b).flatten()
    for i in range(n):
        if(a[i] != b[i]):
            result = False
    return result


def toCharArray(aString):
    msg = numpy.chararray([100])
    msg.fill('\0')
    i = 0
    for c in aString:
        try:
            msg[i] = c
            i = i + 1
        except: pass
    return msg


def test_thread():
    logging.debug("Starting")
    i = 1
    while i:
        i = random.randint(0, 2)
        logging.debug(i)
        time.sleep(i)
    logging.debug("Exiting")

def client_thread(c_sock):
    logging.debug("Starting")
    msg = "Hello"
    mysend(c_sock, msg)
    msg = "Listen!"
    mysend(c_sock, msg)
    msg = ""
    i = 0
    while (not arrayCompN(msg,"Bye", 3)) and i < 200:
        msg = myrecv(c_sock)
        logging.debug("msg: " + msg)
        i = i + 1
    logging.debug("Ending")

def server_thread(port=12345):
    #create an INET, STREAMing socket
    logging.debug("Starting")
    logging.debug("Creating Socket")
    serversocket = socket.socket(
        socket.AF_INET, socket.SOCK_STREAM)
    #bind the socket to a public host,
    # and a well-known port
    logging.debug("Binding to Port: " + str(port))
    serversocket.bind(('', port))
    #become a server socket
    logging.debug("Listening")
    serversocket.listen(5)
    n = 0
    while n < 5:
        #accept connections from outside
        logging.debug("Waiting for connection")
        (clientsocket, address) = serversocket.accept()
        logging.debug(("Connected to " + str(address)))
        n = n + 1 
        #now do something with the clientsocket
        #in this case, we'll pretend this is a threaded server
        t = threading.Thread(target=client_thread, args=(clientsocket,))
        threads.append(t)
        t.start()
    logging.debug("Exiting")

# Main program
logging.info("Starting Server")
t = threading.Thread(target=server_thread, args=(12344,))
threads.append(t)
t.start()
